static const char* const rcsid = "$Id$";
/*                               -*- Mode: C -*- 
 * user-trace.c -- 
 * 
 * Copyright (C) 1997-2005 Francois Felix Ingrand
 * 
 * Author          : Francois Felix Ingrand
 * Created On      : Mon Sep  8 10:34:42 1997
 * Last Modified By: Francois Felix Ingrand
 * Last Modified On: Mon Jul 19 16:18:32 1999
 * Update Count    : 37
 * Status          : OK
 * 
 */

/*	
 * ****************************************************************************
 * ** (c) Copyright 1997-2005 Francois Felix Ingrand.  
 * ** All rights reserved. 
 *
 *   The software, data, and information contained herein are proprietary 
 * to, and comprise valuable trade secrets of Francois Felix Ingrand who 
 * intends to keep such software, data, and information confidential and 
 * to preserve them as trade secrets.  They are given in confidence by 
 * Francois Felix Ingrand pursuant to a written license agreement, and may be 
 * used, copied, transmitted, and stored only in accordance with the 
 * terms of such license.
 * 
 * Francois Felix Ingrand
 * 5, Place du Village d'Entreprises,
 * BP 556,
 * 31674 LABEGE Cedex,
 * FRANCE
 * 
 * RESTRICTED RIGHTS LEGEND
 *    Use, duplication, and disclosure by the Government are subject to 
 * restrictions as set forth in subdivision (c)(1)(ii) of the Rights in 
 * Technical Data and Computer Software Clause at DFAR 52.227-7013.  
 * ****************************************************************************
 */

/*
  Here is a first shoot at a user called trace facility. 

  Basically, the C-OPRS code has been modified to call some predefined function
  when some flags are on. As there is no pointin making such feature in the
  standard kernel, this only works in non standard oprs/xoprs kernel (i.e. it
  only works with the one you build with the relocatables).

  The traces which now accept hooks are close to the standard oprs trace. They can
  be set on or off using the following commands (a similar menu is now
  available under xoprs).

  trace user trace on		; this is the global switch to enable/disable
                                ; the whole mecanism.
  trace user op on              ; trace op execution (goal posting/unposting, action).
  trace user intend on          ; trace when a new op instance is intended
  trace user suc_fail on        ; trace op success/failure.
  trace user send on            ; trace messages sent/broadcasted/multicasted/
  trace user receive on         ; trace messages received.
  trace user fact on            ; trace the new facts posted in the kernel.
  trace user goal on            ; trace the new goals posted in the kernel.
  trace user relevant op on     ; undefinef for now
  trace user applicable op on   ; undefined for now
  trace user thread on          ; undefined for now

  examples of the functions which are called by these user trace are defined
  below. Their prototype are defined in user-trace_f.h.

  each function is exlpained sparately.

*/

#ifdef VXWORKS
#include "vxWorks.h"
#include "stdioLib.h"
#else
#include <stdio.h>
#endif

#include "macro-pub.h"
#include "opaque-pub.h"
#include "constant-pub.h"
#include "oprs-type-pub.h"
#include "fact-goal_f-pub.h"
#include "user-trace.h"
#include "user-trace_f.h"
#include "oprs-print_f-pub.h"


void user_trace_post_goal(Goal *goal)
{
}

void user_trace_post_fact(Fact *fact)
{
}

void user_trace_receive_message(Fact *fact, PString sender)
{
}

void user_trace_send_message(PString message, unsigned int nb_recs, PString *recs)
{
}

void user_trace_suc_fail(Op_Instance *op_ins, Goal* goal, Fact *fact, PBoolean success)
{
}

void user_trace_intend(Thread_Intention_Block *tib,Op_Instance *op_inst)
{
}

void user_trace_op(Thread_Intention_Block *tib,Op_Instance *op_inst, Goal *goal, int what)
{
}

