static const char* const rcsid = "$Id$";
/*                               -*- Mode: C -*- 
 * make-tg.c -- 
 * 
 * Copyright (C) 1999-2005 LAAS/CNRS
 * 
 * Author          : Francois Felix Ingrand
 * Created On      : Mon Jul 19 16:33:48 1999
 * Last Modified By: Francois Felix Ingrand
 * Last Modified On: Sat Sep  4 16:16:50 1999
 * Update Count    : 14
 * Status          : OK
 * 
 */

#include "config.h"

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "slistPack.h"
#include "slistPack_f.h"

#include "macro.h"
#include "transgen.h"
#include "transgen_f.h"
#include "perl-build_f.h"

#define MAKEFILE "auto/Makefile.in"
#define CONFIGURE_AC "configure.ac"
#define CONFIGURE_AC_OUT "autoconf/configure.ac"

void subst_makefile(FILE *perl_file)
{
     print_sed_subst(perl_file, "superv-name", supervisor->name);
     print_sed_subst(perl_file, "superv-cflags", supervisor->cflag);

}

void subst_configure_ac(FILE *perl_file)
{
     Module *module;
     char *modules_name;

     modules_name = NULL;
     print_sed_subst(perl_file, "superv-name", supervisor->name);

     sl_loop_through_slist(supervisor->mod_list, module, Module *) {
	  bufcat(&modules_name, "%s-oprs ", module->name);
     }
     print_sed_subst(perl_file, "modules-list", modules_name);
     FREE(modules_name);
}

PBoolean make_transgen(FILE *perl_file)
{
     script_open(perl_file);
     subst_begin(perl_file, MAKEFILE);
     subst_makefile(perl_file);
     subst_end(perl_file);
     script_close(perl_file, MAKEFILE);

     return TRUE;
}

PBoolean configure_transgen(FILE *perl_file)
{
     script_open(perl_file);
     subst_begin(perl_file, CONFIGURE_AC);
     subst_configure_ac(perl_file);
     subst_end(perl_file);
     script_close(perl_file, CONFIGURE_AC_OUT);

     return TRUE;
}
