static const char* const rcsid = "$Id$";
/*                               -*- Mode: C -*- 
 * superv-tg.c -- 
 * 
 * Copyright (C) 1999-2005 LAAS/CNRS
 * 
 * Author          : Francois Felix Ingrand
 * Created On      : Fri Jul  9 10:07:12 1999
 * Last Modified By: Francois Felix Ingrand
 * Last Modified On: Wed Sep 22 14:06:36 1999
 * Update Count    : 20
 * Status          : OK
 * 
 * $Id$
 */

#include "config.h"

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "slistPack.h"
#include "slistPack_f.h"

#include "macro.h"
#include "transgen.h"
#include "transgen_f.h"
#include "perl-build_f.h"

#define SUPERV_SRC "superv.c"

PBoolean superv_transgen(FILE *perl_file)
{
     Module *module;
     char *include_modules, *declare_modules, *init_enums,
	  *init_rqst_tables, *init_poster_tables;

     include_modules = declare_modules = init_enums =
	  init_rqst_tables = init_poster_tables = NULL;

     script_open(perl_file);
     subst_begin(perl_file, SUPERV_SRC);
     
     print_sed_subst(perl_file, "superv-name", supervisor->name);

     sl_loop_through_slist(supervisor->mod_list, module, Module *) {
	  bufcat(&include_modules,
		 "\n#include \"server/%sMsgLib.h\""
		 "\n#include \"server/openprs/%sRequestsOpenprsProto.h\"\n",
		 module->name,module->name,
		 module->name,module->name);

	  bufcat(&declare_modules,
		 "\n\tdeclare_oprs_module(\"%s\",\"%s_REQUEST\",%sClientInit);",
		 module->NAME,module->NAME,module->name);

	  bufcat(&init_enums,
		 "\n\tinit_%s_module();", module->name);


	  bufcat(&init_rqst_tables,
		 "\n\tinit_%s_rqst_type_table();",
		 module->name);

	  bufcat(&init_poster_tables,
		 "\n\tinit_%s_posters();",
		 module->name);
     }

     if (include_modules) {
	  print_sed_subst(perl_file, "include-modules", include_modules);
	  FREE(include_modules);
     } else {
	  print_sed_subst(perl_file, "include-modules", "");
     }

     if (declare_modules) {
	  print_sed_subst(perl_file, "declare-modules", declare_modules);
	  FREE(declare_modules);
     } else {
	  print_sed_subst(perl_file, "declare-modules", "");
     }

     if (init_enums) {
	  print_sed_subst(perl_file, "init-enums", init_enums);
	  FREE(init_enums);
     } else {
	  print_sed_subst(perl_file, "init-enums", "");
     }

     if (init_rqst_tables) {
	  print_sed_subst(perl_file, "init-rqst-tables", init_rqst_tables);
	  FREE(init_rqst_tables);
     } else {
	  print_sed_subst(perl_file, "init-rqst-tables", "");
     }
     if (init_poster_tables) {
	  print_sed_subst(perl_file, "init-poster-tables", init_poster_tables);
	  FREE(init_poster_tables);
     } else {
	  print_sed_subst(perl_file, "init-poster-tables", "");
     }

     subst_end(perl_file);
     script_close(perl_file, "auto/%s-" SUPERV_SRC, supervisor->name);

     return TRUE;
}
